
Device = 16F877A ' 
Xtal = 4 ' 
                                                                   
Declare  SHOW_SYSTEM_VARIABLES = OFF   '    Proteus    
Declare  FSR_CONTEXT_SAVE = OFF   '       FSR
Declare  Reminders = OFF    '   
Declare  Warnings = OFF   '   
Declare  Optimiser_Level 0    '   
Declare  Bootloader = OFF  '  
  
'--------------------------  USART ----------------------------------



'!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
'   .  ,   
'  ! (    

'--------------------------  USART ----------------------------------
   
'Declare Hserial_Baud 19200          '   
'Declare Hserial_TXSTA = %00100100   '   USART
'Declare Hserial_RCSTA = %10010000   '   USART
'Declare Hserial_Clear = On          '      

'!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! 
  
Declare  Hserial_Clear = On   '     

'--------------------------  ADC ----------------------------------
Declare Adin_Res 10
Declare Adin_Stime 250
Declare Adin_Tad FRC

'--------------------------  LCD ----------------------------------
Declare LCD_Type ALPHA 	    '   -  -
Declare LCD_DTPin PORTB.4 	'   
Declare LCD_ENPin PORTB.3 	'   E
Declare LCD_RSPin PORTB.2 	'   RS
Declare LCD_Interface 4 	'   
Declare LCD_CommandUs 2000 	'    
Declare LCD_DataUs 100 	    '    
Declare LCD_Lines 4 	    '   

Symbol RX9D = RCSTA.0  ' 9th bit of received data (Can be parity bit)
Symbol OERR = RCSTA.1  ' Overrun Error
Symbol FERR = RCSTA.2  ' Framing Error
Symbol ADDEN = RCSTA.3 ' Address Detect Enable
Symbol CREN = RCSTA.4  ' Continuous Receive Enable
Symbol SREN = RCSTA.5  ' Single Receive Enable
Symbol RX9 = RCSTA.6   ' 9-bit Receive Enable
Symbol SPEN = RCSTA.7  ' Serial Port Enable

Symbol TMR1IF = PIR1.0 ' TMR1 Overflow Interrupt Flag
Symbol TMR2IF = PIR1.1 ' TMR2 to PR2 Match Interrupt Flag
Symbol CCP1IF = PIR1.2 ' CCP1 Interrupt Flag
Symbol SSPIF = PIR1.3  ' Synchronous Serial Port (SSP) Interrupt Flag
Symbol TXIF = PIR1.4   ' USART Transmit Interrupt Flag
Symbol RCIF = PIR1.5   ' USART Receive Interrupt Flag
Symbol ADIF = PIR1.6   ' A/D Converter Interrupt Flag
Symbol PSPIF = PIR1.7  ' Parallel Slave Port Read/Write Interrupt Flag

Symbol TMR1IE = PIE1.0 ' TMR1 Overflow Interrupt Enable
Symbol TMR2IE = PIE1.1 ' TMR2 to PR2 Match Interrupt Enable
Symbol CCP1IE = PIE1.2 ' CCP1 Interrupt Enable
Symbol SSPIE = PIE1.3  ' Synchronous Serial Port Interrupt Enable
Symbol TXIE = PIE1.4   ' USART Transmit Interrupt Enable
Symbol RCIE = PIE1.5   ' USART Receive Interrupt Enable
Symbol ADIE = PIE1.6   ' A/D Converter Interrupt Enable
Symbol PSPIE = PIE1.7  ' Parallel Slave Port Read/Write Interrupt Enable bit

'--------------------------   --------------------------------

 
 'Symbol PRE = PIR1.5 '     Usart
'-------------------------- ---------------------------------
 Symbol LED_CHEK = PORTD.0  
 Symbol LED_1 = PORTD.1 
 Symbol LED_2 = PORTD.2 
 Symbol LED_3 = PORTD.3 
 Symbol LED_4 = PORTD.4 
 Symbol LED_5 = PORTD.5 
 Dim result As Byte
 Dim schet As Byte
 Dim A1 As Byte
 Dim A2 As Word
 Dim A3 As Byte
 Dim A4 As Byte
'------------------------- ----------------------------------
 TRISA = %00000001
 TRISB = %00000000
 TRISC = %10000000
 TRISD = %00000000
 
 PORTA = %11111111
 PORTB = %00000000
 PORTC = %10000000
 PORTD = %00000000
 RCSTA = %10010000
 TXSTA = %00000100
 SPBRG = 25
 ADCON1 = %10000000  
 CMCON = 7 '          
 OPTION_REG = %10000000 '   portb    

'-------------------------- ---------------------------------------
INTCON.7 = 1  '    
INTCON.6 = 1  '                                                                                                                    
PIE1.5 = 1    '     Usart
schet = 0
'--------------------------START---------------------------------
On_Interrupt GoTo Obrabotka '  ,    
' ON INTERRUPT ( !)

GoTo Start    '   !
'    ENABLE, DISABLE

Obrabotka:
If schet = 3 Then
  schet = 0
EndIf
  
If RCIF = 1 Then
     If OERR = 1 Then  '  , 
          CREN = 0     '  ( !!!)
          CREN = 1
     EndIf 
     result= RCREG    ' .     (!)
     
    Branch schet, [D_A1, D_A2, D_A3] 
  D_A1: 
   A1 = result
   GoTo Uh
  D_A2:
   A2.LowByte = result
   GoTo Uh  
  D_A3:
   A2.HighByte = result
   GoTo Uh  

  Uh:
  schet = schet + 1 
EndIf

Context Restore

Start:    
Print At 1, 1, "Test v1.1"
DelayMS 1000
Cls


main:
 
Print At 1, 1, schet
Print At 2, 1, A1, "=", Dec5 A2  '      USART 
LED_CHEK = 1
DelayMS 500
LED_CHEK = 0
DelayMS 500                          
GoTo main























